pcl::octree::ColorCoding< PointT > Class Template Reference

ColorCoding class More...

`#include <pcl/compression/color_coding.h>`

## Public Member Functions

| ColorCoding ()
| Constructor. More...
virtual | ~ColorCoding ()
| Empty class constructor. More...
void | setBitDepth (unsigned char bitDepth_arg)
| Define color bit depth of encoded color information. More...
unsigned char | getBitDepth ()
| Retrieve color bit depth of encoded color information. More...
void | setVoxelCount (unsigned int voxelCount_arg)
| Set amount of voxels containing point color information and reserve memory. More...
void | setPointCount (unsigned int pointCount_arg)
| Set amount of points within point cloud to be encoded and reserve memory. More...
void | initializeEncoding ()
| Initialize encoding of color information. More...
void | initializeDecoding ()
| Initialize decoding of color information. More...
std::vector< char > & | getAverageDataVector ()
| Get reference to vector containing averaged color data. More...
std::vector< char > & | getDifferentialDataVector ()
| Get reference to vector containing differential color data. More...
void | encodeAverageOfPoints (const typename std::vector< int > &indexVector_arg, unsigned char rgba_offset_arg, PointCloudConstPtr inputCloud_arg)
| Encode averaged color information for a subset of points from point cloud. More...
void | encodePoints (const typename std::vector< int > &indexVector_arg, unsigned char rgba_offset_arg, PointCloudConstPtr inputCloud_arg)
| Encode color information of a subset of points from point cloud. More...
void | decodePoints (PointCloudPtr outputCloud_arg, std::size_t beginIdx_arg, std::size_t endIdx_arg, unsigned char rgba_offset_arg)
| Decode color information. More...
void | setDefaultColor (PointCloudPtr outputCloud_arg, std::size_t beginIdx_arg, std::size_t endIdx_arg, unsigned char rgba_offset_arg)
| Set default color to points. More...

## Protected Attributes

PointCloudPtr | output_
| Pointer to output point cloud dataset. More...
std::vector< char > | pointAvgColorDataVector_
| Vector for storing average color information More...
std::vector< char >::const_iterator | pointAvgColorDataVector_Iterator_
| Iterator on average color information vector. More...
std::vector< char > | pointDiffColorDataVector_
| Vector for storing differential color information More...
std::vector< char >::const_iterator | pointDiffColorDataVector_Iterator_
| Iterator on differential color information vector. More...
unsigned char | colorBitReduction_
| Amount of bits to be removed from color components before encoding. More...

## Static Protected Attributes

static const int | defaultColor_

## Detailed Description

### template<typename PointT>
class pcl::octree::ColorCoding< PointT >

ColorCoding class

Note
  This class encodes 8-bit color information for octree-based point cloud compression.
  typename: PointT: type of point used in pointcloud

Author
  Julius Kammerl (juliu.nosp@m.s@ka.nosp@m.mmerl.nosp@m..de)

Definition at line 61 of file color_coding.h.

## Constructor & Destructor Documentation

## ColorCoding()

template<typename PointT>

pcl::octree::ColorCoding< PointT >::ColorCoding | ( |  | ) |

inline

Constructor.

Definition at line 74 of file color_coding.h.

## ~ColorCoding()

template<typename PointT>

virtual pcl::octree::ColorCoding< PointT >::~ColorCoding | ( |  | ) |

inline virtual

Empty class constructor.

Definition at line 81 of file color_coding.h.

## Member Function Documentation

## decodePoints()

template<typename PointT>

void pcl::octree::ColorCoding< PointT >::decodePoints | ( | PointCloudPtr | outputCloud_arg,
|  | std::size_t | beginIdx_arg,
|  | std::size_t | endIdx_arg,
|  | unsigned char | rgba_offset_arg
| ) |  |

inline

Decode color information.

Parameters

  outputCloud_arg | output point cloud
  beginIdx_arg | index indicating first point to be assigned with color information
  endIdx_arg | index indicating last point to be assigned with color information
  rgba_offset_arg | offset to color information

Definition at line 291 of file color_coding.h.

## encodeAverageOfPoints()

template<typename PointT>

void pcl::octree::ColorCoding< PointT >::encodeAverageOfPoints | ( | const typename std::vector< int > & | indexVector_arg,
|  | unsigned char | rgba_offset_arg,
|  | PointCloudConstPtr | inputCloud_arg
| ) |  |

inline

Encode averaged color information for a subset of points from point cloud.

Parameters

  indexVector_arg | indices defining a subset of points from points cloud
  rgba_offset_arg | offset to color information
  inputCloud_arg | input point cloud

Definition at line 165 of file color_coding.h.

## encodePoints()

template<typename PointT>

void pcl::octree::ColorCoding< PointT >::encodePoints | ( | const typename std::vector< int > & | indexVector_arg,
|  | unsigned char | rgba_offset_arg,
|  | PointCloudConstPtr | inputCloud_arg
| ) |  |

inline

Encode color information of a subset of points from point cloud.

Parameters

  indexVector_arg | indices defining a subset of points from points cloud
  rgba_offset_arg | offset to color information
  inputCloud_arg | input point cloud

Definition at line 212 of file color_coding.h.

## getAverageDataVector()

template<typename PointT>

std::vector<char>& pcl::octree::ColorCoding< PointT >::getAverageDataVector | ( |  | ) |

inline

Get reference to vector containing averaged color data.

Definition at line 146 of file color_coding.h.

## getBitDepth()

template<typename PointT>

unsigned char pcl::octree::ColorCoding< PointT >::getBitDepth | ( |  | ) |

inline

Retrieve color bit depth of encoded color information.

Returns
  amounts of bits for representing one color component

Definition at line 99 of file color_coding.h.

## getDifferentialDataVector()

template<typename PointT>

std::vector<char>& pcl::octree::ColorCoding< PointT >::getDifferentialDataVector | ( |  | ) |

inline

Get reference to vector containing differential color data.

Definition at line 154 of file color_coding.h.

## initializeDecoding()

template<typename PointT>

void pcl::octree::ColorCoding< PointT >::initializeDecoding | ( |  | ) |

inline

Initialize decoding of color information.

Definition at line 136 of file color_coding.h.

## initializeEncoding()

template<typename PointT>

void pcl::octree::ColorCoding< PointT >::initializeEncoding | ( |  | ) |

inline

Initialize encoding of color information.

Definition at line 126 of file color_coding.h.

## setBitDepth()

template<typename PointT>

void pcl::octree::ColorCoding< PointT >::setBitDepth | ( | unsigned char | bitDepth_arg | ) |

inline

Define color bit depth of encoded color information.

Parameters

  bitDepth_arg | amounts of bits for representing one color component

Definition at line 90 of file color_coding.h.

## setDefaultColor()

template<typename PointT>

void pcl::octree::ColorCoding< PointT >::setDefaultColor | ( | PointCloudPtr | outputCloud_arg,
|  | std::size_t | beginIdx_arg,
|  | std::size_t | endIdx_arg,
|  | unsigned char | rgba_offset_arg
| ) |  |

inline

Set default color to points.

Parameters

  outputCloud_arg | output point cloud
  beginIdx_arg | index indicating first point to be assigned with color information
  endIdx_arg | index indicating last point to be assigned with color information
  rgba_offset_arg | offset to color information

Definition at line 349 of file color_coding.h.

## setPointCount()

template<typename PointT>

void pcl::octree::ColorCoding< PointT >::setPointCount | ( | unsigned int | pointCount_arg | ) |

inline

Set amount of points within point cloud to be encoded and reserve memory.

Parameters

  pointCount_arg | amounts of points within point cloud

Definition at line 118 of file color_coding.h.

## setVoxelCount()

template<typename PointT>

void pcl::octree::ColorCoding< PointT >::setVoxelCount | ( | unsigned int | voxelCount_arg | ) |

inline

Set amount of voxels containing point color information and reserve memory.

Parameters

  voxelCount_arg | amounts of voxels

Definition at line 108 of file color_coding.h.

## Member Data Documentation

## colorBitReduction_

template<typename PointT>

unsigned char pcl::octree::ColorCoding< PointT >::colorBitReduction_

protected

Amount of bits to be removed from color components before encoding.

Definition at line 385 of file color_coding.h.

## defaultColor_

template<typename PointT>

const int pcl::octree::ColorCoding< PointT >::defaultColor_

static protected

Initial value:
= ((255) << 0) |
((255) << 8) |
((255) << 16)

Definition at line 388 of file color_coding.h.

## output_

template<typename PointT>

PointCloudPtr pcl::octree::ColorCoding< PointT >::output_

protected

Pointer to output point cloud dataset.

Definition at line 370 of file color_coding.h.

## pointAvgColorDataVector_

template<typename PointT>

std::vector<char> pcl::octree::ColorCoding< PointT >::pointAvgColorDataVector_

protected

Vector for storing average color information

Definition at line 373 of file color_coding.h.

## pointAvgColorDataVector_Iterator_

template<typename PointT>

std::vector<char>::const_iterator pcl::octree::ColorCoding< PointT >::pointAvgColorDataVector_Iterator_

protected

Iterator on average color information vector.

Definition at line 376 of file color_coding.h.

## pointDiffColorDataVector_

template<typename PointT>

std::vector<char> pcl::octree::ColorCoding< PointT >::pointDiffColorDataVector_

protected

Vector for storing differential color information

Definition at line 379 of file color_coding.h.

## pointDiffColorDataVector_Iterator_

template<typename PointT>

std::vector<char>::const_iterator pcl::octree::ColorCoding< PointT >::pointDiffColorDataVector_Iterator_

protected

Iterator on differential color information vector.

Definition at line 382 of file color_coding.h.

The documentation for this class was generated from the following file:

- pcl/compression/color_coding.h